﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.31
@EndOfDesignText@
'Class module

' Class to manage input sliders (similar to Seekbar) that allows use of images
Private Sub Class_Globals

	Private PtrPos As Double
	Private BarBGOrient As Boolean			' True = Vertical False = Horizontal
	Private MaxVal,MaxMove As Int
	Private BarBG As Panel
	Private Ptr As Panel
	Private Version As String
	Private mTarget As Object
    Private mEventName As String
	Private mAct As Activity
	Private mBase As Panel
	Private DesignerCVCalled As Boolean
	Private Initialized As Boolean

End Sub
'Initializes the object. You can add parameters to this method if needed.
'Initializes the object.
'Required for both designer and code setup. 
'Provides callback {EventName}_ItemClick(Position As Int,Value As Object)
Public Sub Initialize (TargetModule As Object, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
	Version = "1.00"
End Sub
Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	'Check this is not called from setup
	If Not(Props.GetDefault("SLfromsetup",False)) Then DesignerCVCalled = True
	
	'Assign vars to globals
	mBase = Base
	'This is passed from either the designer or setup
	mAct = Props.get("activity")
	
	'mBase.Color = Colors.Yellow
	
	'Initialize Panels
	BarBG.Initialize("BarBG")
	Ptr.Initialize("Ptr")
	
	'Set default colours for panels, allows testing without loading images
	BarBG.Color=Colors.Blue
	Ptr.Color=Colors.Yellow
	
	'Set orientation
	If mBase.Width >= mBase.Height Then BarBGOrient = False Else BarBGOrient = True
	
	mBase.AddView(BarBG,0,0,mBase.Width,mBase.Height)
	
	'Initialize ptr size based on Orientation
	If BarBGOrient Then
		BarBG.AddView(Ptr,0,0,BarBG.Width,BarBG.Width)
		'Load default images if they are in the assets folder
		If File.Exists(File.DirAssets,"sliderbgv.png") Then SetBackGroundImage(LoadBitmap(File.DirAssets,"sliderbgv.png"))
		If File.Exists(File.DirAssets,"sliderbtn.png") Then	SetPointerImage(LoadBitmap(File.DirAssets,"sliderbtn.png"))
	Else
		BarBG.AddView(Ptr,0,0,BarBG.Height,BarBG.Height)
		'Load default images if they are in the assets folder
		If File.Exists(File.DirAssets,"sliderbg.jpg") Then SetBackGroundImage(LoadBitmap(File.DirAssets,"sliderbg.jpg"))
		If File.Exists(File.DirAssets,"sliderbtn.png") Then	SetPointerImage(LoadBitmap(File.DirAssets,"sliderbtn.png"))
	End If
	
	'Default Initializations
	PtrPos = 0
	If BarBGOrient Then
		setmaxmovev
		MaxVal = MaxMove
	Else
		setmaxmoveh
		MaxVal = MaxMove
	End If
	
	MovePtr(0.5)
	
	'Finally
	Initialized = True
End Sub

'Manual Setup of InputSlider Pass Null as Panel if adding to activity
Sub Setup(Act As Activity,Pnl As Panel,Left As Int,Top As Int,Width As Int,Height As Int)

	'Check if DesignerCreateView has been called
	If DesignerCVCalled Then
		LogColor("You should not call setup if you have defined this view in the designer",Colors.Red)
		Return
	End If
	
	mAct = Act
	
	'Create our own base panel
	Dim Base As Panel
	Base.Initialize("")
	
	'If Null was passed, a Panel wii be created by casting, but it won't be initialized
	If Pnl.IsInitialized Then
		Pnl.AddView(Base,Left,Top,Width,Height)
	Else
		Act.AddView(Base,Left,Top,Width,Height)
	End If
		
	'Set up vars to pass to DesignerCreateView so we don't have to maintain two identical subs
	Dim M As Map
	M.Initialize
	M.Put("activity",mAct)
	'As we are passing a map, we can use it to pass an additional flag for our own use 
	'with an ID unlikely To be used by B4a In the future
	M.Put("SLfromsetup",True)
	
	'We need a label to pass to DesignerCreateView
	Dim L As Label
	L.Initialize("")
	'Default text size
	'Default size for custom view text in designer is 14
	'Default For a Spinner Is 16, I didn't want to enforce this as you wouldn't then be able to change the size in the designer
	'and a default SLSpinner added in designer would look different to one added in code.
	L.TextSize = 14						
	L.Typeface = Typeface.DEFAULT
	L.Gravity = Gravity.CENTER_VERTICAL
	'Leave TextColor as default. Color is write only so we can't copy it, don't bother setting it
	
	DesignerCreateView(Base,L,M)

End Sub
'Set size of the Bar Background, -1 leaves parameter as is
Sub SetBarBGSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then mBase.Left=Left
	If Top <> -1 Then mBase.Top=Top
	If Width <> -1 Then 
		mBase.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		mBase.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
	BarBG.SetLayout(mBase.Left,mBase.Top,mBase.Width,mBase.Height)
End Sub
'Set size of the Pointer Background, -1 leaves parameter as is
Sub SetPtrSize(Left As Int,Top As Int,Width As Int,Height As Int)
	If Left <> -1 Then Ptr.Left=Left
	If Top <> -1 Then Ptr.Top=Top
	If Width <> -1 Then 
		Ptr.Width=Width
		If BarBGOrient = False Then setmaxmoveh
	End If
	If Height <> -1 Then 
		Ptr.Height=Height
		If BarBGOrient Then setmaxmovev
	End If
End Sub
'Set Bar background image as BitmapDrawable
Sub SetBackGroundImage(Image As Bitmap)
	BarBG.SetBackGroundImage(Image)
End Sub
'Set Pointer background Image as BitmapDrawable
Sub SetPointerImage(Image As Bitmap)
	Ptr.SetBackGroundImage(Image)
End Sub
'Set MaxVal Value
Sub SetMaxVal(sMaxVal As Int)
	MaxVal=sMaxVal
End Sub
'Set Current Position (0 - 1) 
Sub SetPos(sValue As Double)
	PtrPos=sValue
	MovePtr(sValue)
End Sub
'Set Current Value *** Set MaxVal first
Sub SetValue (sPos As Double)
	PtrPos=sPos/MaxVal
	MovePtr(PtrPos)
End Sub
Private Sub BarBG_touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		If BarBGOrient Then
			
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
	End If
	If Action = 1 And SubExists(mTarget,mEventName&"_Released") Then
		CallSub2(mTarget,mEventName&"_Released",GetValue)
		Return
	End If
	If Action = 2 Then
		If BarBGOrient Then
			
			MovePtr(Min(Max(0,Y *(MaxMove/BarBG.Height)),MaxMove)/MaxMove)
		Else
			'BarBG is horizontal
			
			MovePtr(Min(Max(0,X *(MaxMove/BarBG.Width)),MaxMove)/MaxMove)
		End If
	End If
	
End Sub
Private Sub MovePtr(Pos As Double)
	PtrPos=Pos
	If BarBGOrient Then
		Ptr.Top = Pos*MaxMove
	Else
		Ptr.Left=Pos*MaxMove
	End If
	
	'Check for call back subs and call if available
	If SubExists(mTarget,mEventName&"_ValueChanged") Then
			CallSub2(mTarget,mEventName&"_ValueChanged",GetValue)
	End If
	
	If SubExists(mTarget,mEventName&"_PosChanged") Then
			CallSub2(mTarget,mEventName&"_PosChanged",PtrPos)
	End If
End Sub
'Get the calculated value from the InputSlider
Sub GetValue As Int
	Return PtrPos*MaxVal
End Sub
'Returns position as float range 0-1
Sub GetPos As Float
	Return PtrPos
End Sub

'Get the panel that holds the Customview
Public Sub GetBase As Panel
	Return mBase
End Sub

Sub IsInitialized As Boolean
	Return Initialized
End Sub
Private Sub setmaxmovev
	'Determine maximum move allowed
	MaxMove=BarBG.Height-Ptr.Height
End Sub
Private Sub setmaxmoveh
	'Determine maximum move allowed
	MaxMove=BarBG.Width-Ptr.Width
End Sub
Sub GetVersion As String
	Return Version
End Sub